﻿String.prototype.capitalize = function () {
    return this.charAt(0).toUpperCase() + this.slice(1);
}

String.prototype.replaceAll = function (search, replacement) {
    var target = this;
    return target.split(search).join(replacement);
};

function findWithAttr(array, attr, value) {
    for (var i = 0; i < array.length; i += 1) {
        if (array[i][attr] === value) {
            return i;
        }
    }
    return -1;
}


jQuery(function ($) {

    var _oldShow = $.fn.show;

    $.fn.show = function (speed, oldCallback) {
        return $(this).each(function () {
            var obj = $(this),
                newCallback = function () {
                    if ($.isFunction(oldCallback)) {
                        oldCallback.apply(obj);
                    }
                    obj.trigger('afterShow');
                };

            // you can trigger a before show if you want
            obj.trigger('beforeShow');

            // now use the old function to show the element passing the new callback
            _oldShow.apply(obj, [speed, newCallback]);
        });
    }
});

(function ($) {
    if ($.fn.style) {
        return;
    }

    // Escape regex chars with \
    var escape = function (text) {
        return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
    };

    // For those who need them (< IE 9), add support for CSS functions
    var isStyleFuncSupported = !!CSSStyleDeclaration.prototype.getPropertyValue;
    if (!isStyleFuncSupported) {
        CSSStyleDeclaration.prototype.getPropertyValue = function (a) {
            return this.getAttribute(a);
        };
        CSSStyleDeclaration.prototype.setProperty = function (styleName, value, priority) {
            this.setAttribute(styleName, value);
            var priority = typeof priority != 'undefined' ? priority : '';
            if (priority != '') {
                // Add priority manually
                var rule = new RegExp(escape(styleName) + '\\s*:\\s*' + escape(value) +
                    '(\\s*;)?', 'gmi');
                this.cssText =
                    this.cssText.replace(rule, styleName + ': ' + value + ' !' + priority + ';');
            }
        };
        CSSStyleDeclaration.prototype.removeProperty = function (a) {
            return this.removeAttribute(a);
        };
        CSSStyleDeclaration.prototype.getPropertyPriority = function (styleName) {
            var rule = new RegExp(escape(styleName) + '\\s*:\\s*[^\\s]*\\s*!important(\\s*;)?',
                'gmi');
            return rule.test(this.cssText) ? 'important' : '';
        }
    }

    // The style function
    $.fn.style = function (styleName, value, priority) {
        // DOM node
        var node = this.get(0);
        // Ensure we have a DOM node
        if (typeof node == 'undefined') {
            return this;
        }
        // CSSStyleDeclaration
        var style = this.get(0).style;
        // Getter/Setter
        if (typeof styleName != 'undefined') {
            if (typeof value != 'undefined') {
                // Set style property
                priority = typeof priority != 'undefined' ? priority : '';
                style.setProperty(styleName, value, priority);
                return this;
            } else {
                // Get style property
                return style.getPropertyValue(styleName);
            }
        } else {
            // Get CSSStyleDeclaration
            return style;
        }
    };
})(jQuery);

var Base64 = { _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", encode: function (e) { var t = ""; var n, r, i, s, o, u, a; var f = 0; e = Base64._utf8_encode(e); while (f < e.length) { n = e.charCodeAt(f++); r = e.charCodeAt(f++); i = e.charCodeAt(f++); s = n >> 2; o = (n & 3) << 4 | r >> 4; u = (r & 15) << 2 | i >> 6; a = i & 63; if (isNaN(r)) { u = a = 64 } else if (isNaN(i)) { a = 64 } t = t + this._keyStr.charAt(s) + this._keyStr.charAt(o) + this._keyStr.charAt(u) + this._keyStr.charAt(a) } return t }, decode: function (e) { var t = ""; var n, r, i; var s, o, u, a; var f = 0; e = e.replace(/[^A-Za-z0-9\+\/\=]/g, ""); while (f < e.length) { s = this._keyStr.indexOf(e.charAt(f++)); o = this._keyStr.indexOf(e.charAt(f++)); u = this._keyStr.indexOf(e.charAt(f++)); a = this._keyStr.indexOf(e.charAt(f++)); n = s << 2 | o >> 4; r = (o & 15) << 4 | u >> 2; i = (u & 3) << 6 | a; t = t + String.fromCharCode(n); if (u != 64) { t = t + String.fromCharCode(r) } if (a != 64) { t = t + String.fromCharCode(i) } } t = Base64._utf8_decode(t); return t }, _utf8_encode: function (e) { e = e.replace(/\r\n/g, "\n"); var t = ""; for (var n = 0; n < e.length; n++) { var r = e.charCodeAt(n); if (r < 128) { t += String.fromCharCode(r) } else if (r > 127 && r < 2048) { t += String.fromCharCode(r >> 6 | 192); t += String.fromCharCode(r & 63 | 128) } else { t += String.fromCharCode(r >> 12 | 224); t += String.fromCharCode(r >> 6 & 63 | 128); t += String.fromCharCode(r & 63 | 128) } } return t }, _utf8_decode: function (e) { var t = ""; var n = 0; var r = c1 = c2 = 0; while (n < e.length) { r = e.charCodeAt(n); if (r < 128) { t += String.fromCharCode(r); n++ } else if (r > 191 && r < 224) { c2 = e.charCodeAt(n + 1); t += String.fromCharCode((r & 31) << 6 | c2 & 63); n += 2 } else { c2 = e.charCodeAt(n + 1); c3 = e.charCodeAt(n + 2); t += String.fromCharCode((r & 15) << 12 | (c2 & 63) << 6 | c3 & 63); n += 3 } } return t } }

function unpack(code) {
    function indent(code) {
        try {
            var tabs = 0, old = -1, add = '';
            for (var i = 0; i < code.length; i++) {
                if (code[i].indexOf("{") != -1) tabs++;
                if (code[i].indexOf("}") != -1) tabs--;

                if (old != tabs) {
                    old = tabs;
                    add = "";
                    while (old > 0) {
                        add += "\t";
                        old--;
                    }
                    old = tabs;
                }

                code[i] = add + code[i];
            }
        } finally {
            tabs = null;
            old = null;
            add = null;
        }
        return code;
    }

    var env = {
        eval: function (c) {
            code = c;
        },
        window: {},
        document: {}
    };

    eval("with(env) {" + code + "}");

    code = (code + "").replace(/;/g, ";\n").replace(/{/g, "\n{\n").replace(/}/g, "\n}\n").replace(/\n;\n/g, ";\n").replace(/\n\n/g, "\n");

    code = code.split("\n");
    code = indent(code);

    code = code.join("\n");


    try {
        c = code.split('m3u8')[1].split('file:"')[1].split('"')[0];
    } catch (e) {
        try {
            c = code.split('file:"')[1].split('"')[0];
        }
        catch (e) {
            try {
                c = code.split('src","')[1].split('"')[0];
            } catch (ex) {
                try {
                    c = code.split('src:\'')[1].split('\'')[0];
                } catch (ex) {
                    try {
                    c = code.split('sources:["')[1].split('"')[0];
					} catch (ex) {
                        
                        try {
                            c = code.split('file:\'')[1].split('\'')[0];
                        } catch (ex) {
                            try {
                                c = code.split('source:\'')[1].split('\'')[0];
                            } catch (ex) {
                                c = code;
                            }
                        }
					}
                }
            }

        }
    }
    
    return c;
}

function sortBy(property) {
    debugger
    var sortOrder = 1;
    if (property[0] === "-") {
        sortOrder = -1;
        property = property.substr(1);
    }
    return function (a, b) {

        var isSeason = false;

        if(a[property].indexOf("Stagione") > -1){
            a["season"] = parseInt(a[property].split(" ")[1].trim());
        }

        if(b[property].indexOf("Stagione") > -1){
            b["season"] = parseInt(b[property].split(" ")[1].trim());
            isSeason = true;
        }

        var result = 0;
        
        if(!isSeason)
            result = (a[property] < b[property]) ? -1 : (a[property] > b[property]) ? 1 : 0;
        else
            result = (a["season"] < b["season"]) ? -1 : (a["season"] > b["season"]) ? 1 : 0;


        return result * sortOrder;
    }
}



//HTTP GET
function get(url, success, error, referer) {
    if (!window.cordova) {
        $.ajax({
            url: url,
            type: "GET",
            success: function (response) {
                success(response);
            },
            error: function (e) {
                error(e);
            }
        });
    } else {
        cordovaHTTP.headers = [];
        cordovaHTTP.setHeader("User-Agent", "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.8; rv:18.0) Gecko/20100101 Firefox/18.0");
        if(referer){
            cordovaHTTP.setHeader("Referer", referer);
        }
        cordovaHTTP.get(url, {}, {}, function (response) {
            success(response.data);
        }, function (response) {
            error(response);
        });
    }
}

function post(url, parameters, success, error, notHeader) {
    //if (!window.cordova) {

        var header = notHeader ? "" : function(xhr) {
            xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        };

        $.ajax({
            url: url,
            type: "POST",
            beforeSend: header,
            data: parameters,
            success: function (response) {
                success(response)
            },
            error: function (e) {
                error(e);
            }
        });
    //} else {
    //    cordovaHTTP.headers = [];

    //    if(!notHeader)
    //        cordovaHTTP.setHeader("Content-Type", "application/x-www-form-urlencoded");

    //    cordovaHTTP.post(url, parameters, {}, function (response) {
    //        success(response.data);
    //    }, function (e) {
    //        error(e);
    //    });
    //}
}


function log(page, functionName, ex, html, level) {

    return;

    if (ex.message && ex.stack)
        ex = "Message:" + ex.message + " - stack:" + ex.stack;


    try {
        html = Base64.encode(JSON.stringify(html));
    } catch (e) {
        html = Base64.encode(html);
    }

    var movie = "";
    try {
        if (localStorage.currentMovieId != undefined && localStorage.currentMovieId != "undefined")
            movie = "Movie=" + localStorage.currentMovieId + " - Episode=" + localStorage.currentEpisode;
    } catch (e) {

    }

    var userInfo = { email: "anonymous" };

    if (localStorage.userInfo)
     userInfo = JSON.parse(localStorage.userInfo);

    if (!level)
        level = "error";

    var json = {
        "page": localStorage.currentChannel + "-" + page,
        "user": userInfo.email,
        "level": level,
        "function": functionName + " - " + movie,
        "exception": ex,
        "html": html
    }

    $.ajax({
        url: apiBaseUrl + "log",
        type: "PUT",
        data: JSON.stringify(json),
        success: function (response) {
            console.log(response);
        },
        error: function (e) {
            try {
                ex = Base64.encode(JSON.stringify(ex));
            } catch (e) {
                ex = Base64.encode(ex);
            }

            var json = {
                "page": localStorage.currentChannel + "-" + page,
                "user": userInfo.email,
                "level": level,
                "function": functionName + " - " + movie,
                "exception": ex,
                "html": html
            }

            $.ajax({
                url: apiBaseUrl + "log",
                type: "PUT",
                data: JSON.stringify(json),
                success: function (response) {
                    console.log(response);
                },
                error: function (e) {
                    console.error(e);
                }
            });

        }
    });
}


//SOTTOTITOLI ////////////////////////////////////////////

function parseSrt(url, callback) {
    //define variable type - Array
    var subtitles = [];
    jQuery.get(url, function (data) {
        function strip(s) {
            return s.replace(/^\s+|\s+$/g, "");
        }
        var srt = data.replace(/\r\n|\r|\n/g, '\n');

        srt = strip(srt);

        var srt_ = srt.split('\n\n');

        var cont = 0;

        for (s in srt_) {
            st = srt_[s].split('\n');
            try {
                if (st.length >= 2) {
                    n = st[0];

                    i = strip(st[1].split(' --> ')[0]);
                    o = strip(st[1].split(' --> ')[1]);
                    t = st[2];

                    if (st.length > 2) {
                        for (j = 3; j < st.length; j++)
                            t += '\n' + st[j];
                    }

                    //define variable type as Object
                    subtitles[cont] = {};
                    subtitles[cont].number = n;
                    subtitles[cont].start = conv2seconds(i);
                    subtitles[cont].end = conv2seconds(o);
                    subtitles[cont].text = t;

                }
                cont++;
            } catch (e) {
                
            }
        }

        callback(subtitles);

    });

    function conv2seconds(time) {
        var cm;
        var timeSplit = time.split(":");

        var hours = parseInt(timeSplit[0]);
        var minute = parseInt(timeSplit[1]);
        var seconds = parseFloat(timeSplit[2].replace(",", "."));
        cm = hours * (60 * 60) + minute * 60 + seconds * 1;
        return cm;
    }

}

function setSubtitleOffset(offset) {
    for (var i = 0; i < cues.length; i++) {
        cues[i].startTime = cues[i].startTime + offset;
        cues[i].endTime = cues[i].endTime + offset;
    }

    videojs("player").textTracks().tracks_ = [];
    $('.vjs-menu-item.vjs-selected')[1].remove();

    var track2 = videojs("player").addTextTrack('subtitles', 'subtitles', 'en');
    track2.mode = 'showing';
    for (var i = 0; i < cues.length; i++) {
        track2.addCue(new VTTCue(cues[i].startTime, cues[i].endTime, cues[i].text));
    }
}

function clearCache() {
    if (localStorage.timeStampClearCache == undefined)
        localStorage.timeStampClearCache = new Date();

    if (new Date(localStorage.timeStampClearCache).getTime() < new Date().getTime()) {
        var channels = localStorage.channelList;
        var cache = localStorage.timeStampClearCache;
        var userInfo = localStorage.userInfo;
        var lang = localStorage.lang;
        var favourites = localStorage.favourites;
        var bookmarks = localStorage.bookmarks;
        var downloadEpisodeInfo = localStorage.downloadEpisodeInfo;
        var settings = localStorage.settings;
        var firstAccess = localStorage.firstAccess;
        var lastSync = localStorage.lastSync;
        var lastLogin = localStorage.lastLogin;
        var localLibrary = localStorage.localLibrary;
        var isPremium = localStorage.isPremium;
        var nextSchedule = localStorage.nextSchedule;
        var blockCalendar = localStorage.blockCalendar;
        var privacy = localStorage.privacy3;
        var news = localStorage.news3;


        localStorage.clear();

        
        if (bookmarks)
            localStorage.bookmarks = bookmarks;
        if (favourites)
            localStorage.favourites = favourites;
        if (downloadEpisodeInfo)
            localStorage.downloadEpisodeInfo = downloadEpisodeInfo;
        if (cache)
            localStorage.timeStampClearCache = cache;
        if (channels)
            localStorage.channelList = channels;
        if (userInfo)
            localStorage.userInfo = userInfo;
        if (lang)
            localStorage.lang = lang;
        if (settings)
            localStorage.settings = settings;
        if (firstAccess)
            localStorage.firstAccess = firstAccess;
        if (lastSync)
            localStorage.lastSync = lastSync;
        if (lastLogin)
            localStorage.lastLogin = lastLogin;
        if (localLibrary)
            localStorage.localLibrary = localLibrary;
        if (isPremium)
            localStorage.isPremium = isPremium;
        if (nextSchedule)
            localStorage.nextSchedule = nextSchedule;
        if (blockCalendar)
            localStorage.blockCalendar = blockCalendar;
        if (privacy)
            localStorage.privacy3 = privacy;
		if (news)
            localStorage.news3 = news;

        localStorage.timeStampClearCache = new Date().addDays(90);
    }
}

Date.prototype.addDays = function (days) {
    var dat = new Date(this.valueOf());
    dat.setDate(dat.getDate() + days);
    return dat;
}
Date.prototype.addHours = function (h) {
    this.setTime(this.getTime() + (h * 60 * 60 * 1000));
    return this;
}


function similarity(s1, s2) {
    var longer = s1;
    var shorter = s2;
    if (s1.length < s2.length) {
      longer = s2;
      shorter = s1;
    }
    var longerLength = longer.length;
    if (longerLength == 0) {
      return 1.0;
    }
    return (longerLength - editDistance(longer, shorter)) / parseFloat(longerLength);
  }

  function editDistance(s1, s2) {
    s1 = s1.toLowerCase();
    s2 = s2.toLowerCase();
  
    var costs = new Array();
    for (var i = 0; i <= s1.length; i++) {
      var lastValue = i;
      for (var j = 0; j <= s2.length; j++) {
        if (i == 0)
          costs[j] = j;
        else {
          if (j > 0) {
            var newValue = costs[j - 1];
            if (s1.charAt(i - 1) != s2.charAt(j - 1))
              newValue = Math.min(Math.min(newValue, lastValue),
                costs[j]) + 1;
            costs[j - 1] = lastValue;
            lastValue = newValue;
          }
        }
      }
      if (i > 0)
        costs[s2.length] = lastValue;
    }
    return costs[s2.length];
  }


window.downloadFile = function (sUrl) {

    //iOS devices do not support downloading. We have to inform user about this.
    if (/(iP)/g.test(navigator.userAgent)) {
        alert('Your device does not support files downloading. Please try again in desktop browser.');
        return false;
    }

    //If in Chrome or Safari - download via virtual link click
    if (window.downloadFile.isChrome || window.downloadFile.isSafari) {
        //Creating new link node.
        var link = document.createElement('a');
        link.href = sUrl;

        if (link.download !== undefined) {
            //Set HTML5 download attribute. This will prevent file from opening if supported.
            var fileName = sUrl.substring(sUrl.lastIndexOf('/') + 1, sUrl.length);
            link.download = fileName;
        }

        //Dispatching click event.
        if (document.createEvent) {
            var e = document.createEvent('MouseEvents');
            e.initEvent('click', true, true);
            link.dispatchEvent(e);
            return true;
        }
    }

    // Force file download (whether supported by server).
    if (sUrl.indexOf('?') === -1) {
        sUrl += '?download';
    }

    window.open(sUrl, '_self');
    return true;
}

function getKey(obj, i) {
    var j = 0;
    for (var p in obj) {
        if (j++ == i) return p;
    }
    return null;
}

window.downloadFile.isChrome = navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
window.downloadFile.isSafari = navigator.userAgent.toLowerCase().indexOf('safari') > -1;

function calculateSizeLocandina($scope){
    var container = $(window).width()-15;
    var border = 30;
    if(container > 800)
        border = 50;

    container = container - border;

    var size = container / 9;

    if(!localStorage.posterSize)
        localStorage.posterSize = 110;

    var minSize = parseInt(localStorage.posterSize);

    if(size < minSize)
        size = container / 8;

    if(size < minSize)
        size = container / 7;

    if(size < minSize)
        size = container / 6;

    if(size < minSize)
    size = container / 5;

    if(size < minSize)
    size = container / 4;

    if(size < minSize)
    size = container / 3;

    if(size < minSize)
    size = container / 2;

    var height = size *1.5;
    $scope.sizeLocandina = {
        "width": size + "px",
        "height": height + "px"
    }

}